/*
  	#[ Include file :
*/
#include "stedi.h"
/*
  	#] Include file :
 	#[ Basic operations :
 		#[ Insert Character in text : LONG Cinsert(sc,n)
*/

LONG
Cinsert(UBYTE *sc,WORD n)
{
/*
  	#[ Declarations and startup :
*/
	BUFFER b = cbuf;
	LINE l, l2;
	UBYTE *s, *t;
	FINDPOS fp;
	WORD type, num, virt, num1, num2, old1, old2, spec = 0;
	if ( b->iomode == OVERSTRIKEMODE && n > 1 ) {
		LONG RetCode;
		while ( n > 1 ) {
			if ( ( RetCode = Cinsert(sc,1) ) < 0 ) return(RetCode);
			sc++; n--;
		}
	}
	if ( n <= 0 ) return(0);
	if ( commandmode ) { b = commandbuffer; commandmode = 1; }
	l = b->current;
/*
  	#] Declarations and startup :
  	#[ Make virtual lines real :
*/
	while ( b->newvirt > 0 ) {
		if ( ( l2 = LineAlloc(0,b->current) ) == 0 ) {
			while ( l->next != (LINE)b ) {
				if ( b->mark->next == (LINE)b ) { b->mark = l; b->MarkVirt++; }
				else if ( b->MarkVirt > 0 ) b->MarkVirt++;
				LineDealloc(l->next);
				b->newvirt++;
				b->newline--;
				b->totline--;
			}
			b->current = l;
			return(NOMEMORYL);
		}
		b->newvirt--;
		b->newline++;
		b->totline++;
		if ( b->oldline == 0 ) { b->oldline = 1; b->oldvirt--; }
		b->current = l2;
		if ( b->MarkVirt > 0 ) { b->MarkVirt--; b->mark = l2; }
	}
/*
  	#] Make virtual lines real :
  	#[ Get position :
*/
	b->dirtyflag = 1;
	l = b->current;
	if ( l->used < 0 ) return(NoFold());
	type = FindChar(l,b->column,&fp);
	num = fp.num; virt = fp.virt;
	num2 = l->used - LINEHEAD;
	if ( type == NORMALEOL || type == AFTERVIRTUAL ) {
		num1 = num2;
		num2 = 0;
	}
	else {
		num1 = num - 1;
		num2 -= num1;
		if ( type != INSIDETAB ) {
			if ( b->iomode == OVERSTRIKEMODE ) { spec = 1; fp.address++; num2--; }
		}
		if ( type != NORMALCHAR ) {
			if ( *sc == '\t' ) virt = 0;
		}
	}
	virt++;					/* include the new character */
/*
  	#] Get position :
  	#[ Move the mark :
*/
	old1 = b->MarkChar;
	old2 = b->MarkVoff;
	if ( ( b->mark == l ) && ( b->MarkVirt == 0 ) ) {
		if ( b->MarkChar == num ) {
			if ( type == INSIDETAB ) {
				if ( -b->MarkVoff > virt ) {
					b->MarkVoff += virt;
					b->MarkChar += virt;
				}
				else {
					if ( b->MarkVoff >= 0 ) {
						b->MarkChar += b->MarkVoff;
					}
					else {
						b->MarkChar -= b->MarkVoff;
					}
					b->MarkVoff  = 0;
				}
			}
			else if ( ( type == NORMALEOL ) || ( type == AFTERVIRTUAL ) ) {
				if ( b->MarkVoff > virt ) {
					b->MarkVoff -= virt;
					b->MarkChar += virt;
				}
				else if ( b->MarkVoff > 0 ) {
					b->MarkChar += b->MarkVoff - 1;
					b->MarkVoff  = 0;
				}
			}
			else {
				b->MarkChar += virt;
				if ( b->iomode == OVERSTRIKEMODE ) b->MarkChar--;
			}
		}
		else if ( b->MarkChar > num ) {
			b->MarkChar += virt + n-1;
/*
			if ( ( b->iomode == OVERSTRIKEMODE ) &&
			( ( type == NORMALCHAR ) || ( type == ONTAB ) ) ) b->MarkChar--;
*/
			if ( spec ) b->MarkChar--;
		}
	}
/*
  	#] Move the mark :
  	#[ Insert the character :

	Now to do: Copy num1 characters, put in virt blanks, put in sc
	and finish with copying num2 characters.
*/
	num = num1 + num2 + virt + n-1;
	if ( num > MAXINLINE ) {
		MesnOut(14);
		goto ExitFast;
	}
	if ( ( num + LINEHEAD ) > l->totlen ) {
		if ( ( l2 = LineAlloc(num,l) ) == (LINE)0 ) {
ExitFast:
			b->MarkChar = old1;
			b->MarkVoff = old2;
			return(NOMEMORYL);
		}
		num = num1 + virt + n-1;		/* For column computations. */
		t = l->text;
		s = l2->text;
		while ( --num1 >= 0 ) *s++ = *t++;
		while ( --virt > 0 ) *s++ = ' ';
		while ( --n >= 0 ) *s++ = *sc++;
		if ( spec ) t++;
/*
		if ( ( ( type == NORMALCHAR ) || ( type == ONTAB ) ) &&
			( b->iomode == OVERSTRIKEMODE ) ) t++;
*/
		while ( --num2 >= 0 ) *s++ = *t++;
		if ( b->mark == l ) b->mark = l2;
		LineDealloc(l);
		b->current = l = l2;
	}
	else {
		l->used = num + LINEHEAD;
		num = num1 + virt + n-1;
		t = fp.address + num2;
		s = t + virt + n-1;
		if ( spec ) s--;
/*
		if ( ( ( type == NORMALCHAR ) || ( type == ONTAB ) ) &&
			( b->iomode == OVERSTRIKEMODE ) ) s--;
*/
		while ( --num2 >= 0 ) *--s = *--t;
		sc += n;
		while ( --n >= 0 ) *--s = *--sc;
		while ( --virt > 0 ) *--s = ' ';
	}
	if ( b->mark == l ) DetMarkColumn();
	b->column = FindColumn(l,num) + 1;
/*
  	#] Insert the character :
*/
	return(0L);
}

/*
 		#] Insert Character in text :
 		#[ Insert linefeed in text :
*/

LONG
Linsert(VOID)
{
/*
  	#[ Declarations and startup :
*/
	BUFFER b = cbuf;
	LINE l, l2 = 0;
	WORD num, virt, type, old1, old2, movemark, num4, num5, type2;
	WORD num1, num2, num3, aut;
	UBYTE *s, *t = 0;
	FINDPOS fp, fpp;
	b->dirtyflag = 1;
	l = b->current;
/*
  	#] Declarations and startup :
  	#[ Virtual lines :

		If in a virtual line, we make them all real and go to the next line.

 */
	if ( b->newvirt > 0 ) {
		while ( b->newvirt > 0 ) {
			if ( ( l2 = LineAlloc(0,b->current) ) == 0 ) {
				while ( l->next != (LINE)b ) {
					if ( b->mark->next == (LINE)b ) { b->mark = l; b->MarkVirt++; }
					else if ( b->MarkVirt > 0 ) b->MarkVirt++;
					LineDealloc(l->next);
					b->newvirt++;
					b->newline--;
					b->totline--;
				}
				return(NOMEMORYL);
			}
			b->newvirt--;
			b->newline++;
			b->totline++;
			b->current = l2;
			if ( b->MarkVirt > 0 ) { b->MarkVirt--; b->mark = l2; }
		}
		if ( b->autoindent == 0 ) {
			b->newvirt = 1;
			b->column  = 1;
			return(0L);
		}
		else {
			b->column = 1;
			l = l2;
		}
	}
/*
  	#] Virtual lines :
  	#[ Get Position :
*/
	if ( ( l->used < 0 ) && ( b->column == 1 ) ) {
		if ( ( l = LineAlloc(0,l->prev) ) == (LINE)0 ) return(NOMEMORYL);
		b->totline++; b->newline++; return(0L);
	}
	type = FindChar(l,b->column,&fp);
	num = fp.num; virt = fp.virt;
	if ( ( type == NORMALEOL ) || ( type == AFTERVIRTUAL ) ) {
		if ( ( l == b->last ) && !b->autoindent ) {
			if ( ( b->mark == l ) && ( b->MarkColumn >= b->column ) &&
				( b->MarkVirt == 0 ) ) {
				b->MarkVirt = 1;
				b->MarkChar = 0;
				b->MarkVoff = b->MarkColumn = b->column - b->MarkColumn;
			}
			b->newvirt = 1;
			b->column = 1;
			return(0L);
		}
		num1 = LENGTH(l);
		num2 = 0;
	}
	else {		/* INSIDETAB, ONTAB, NORMALCHAR */
		if ( l->used < 0 ) return(NoFold());
		num1 = num - 1;
		num2 = l->used - num + 1 - LINEHEAD;
	}
/*
  	#] Get Position :
  	#[ AutoIndent :

	Compute here the autoindent --> get num4 tabs, num5 blanks
			and copy num3 characters from the previous line.
*/
	num3 = num4 = num5 = 0;
#ifndef DEMO
	if ( b->autoindent && ( l != (LINE)b ) ) {
		if ( ( b->autoindent > 1 ) || ( b->autoindent < 0 ) ) {
			aut = b->autoindent;
			s = b->tabstring;
			if ( aut < 0 ) aut = -aut;
			aut -= 2;
			while ( ( aut >= *s ) && *s ) { num4++; s++; }
			num5 = ++aut;
			if ( num4 ) { num5 -= *--s + 1; }
			if ( b->autoindent > 0 ) {
				aut++;
				type2 = FindChar(l,aut,&fpp);
				if ( ( type2 == ONTAB ) || ( type2 == INSIDETAB ) ) num5 = 0;
				s = t = fpp.address;
				if ( type2 != AFTERVIRTUAL && type2 != NORMALEOL ) {
					fpp.virt = LENGTH(l);
					while ( ( ( *s == ' ' ) || ( *s == '\t' ) ) &&
						( fpp.num <= fpp.virt ) ) { fpp.num++; num3++; s++; }
				}
			}
		}
		else {		/* Normal autoindent */
			if ( l->used >= 0 ) t = l->text;
			else				t = ((FOLDLINE)l)->text;
			s = t;
			fpp.virt = LENGTH(l);
/*
			The code below should be addapted:
			One should take no more characters than till the original column.
*/
			while ( ( ( *s == ' ' ) || ( *s == '\t' ) )
			&& ( num3 < fpp.virt ) ) {
				if ( num3 == num1 ) break;
				num3++;
				s++;
			}


		}
	}
#endif
/*
  	#] AutoIndent :
  	#[ Move Mark :

	Now get the mark moved if needed.
*/
	movemark = 0;
	old1 = b->MarkChar;
	old2 = b->MarkVoff;
	if ( b->mark == l ) {
		if ( b->MarkChar == num ) {
			if ( ( b->MarkVoff > virt ) && ( type != INSIDETAB ) ) {
				b->MarkVoff -= virt;
				b->MarkChar = num3 + num4 + num5;
				if ( ( type == NORMALCHAR ) || ( type == ONTAB ) ) b->MarkChar++;
				movemark = 1;
			}
			else if ( ( b->MarkVoff <= -virt ) && ( type == INSIDETAB ) ) {
				b->MarkVoff += virt;
				b->MarkChar = num3 + num4 + num5 + 1;
				movemark = 1;
			}
		}
		else if ( b->MarkChar >= num ) {
			movemark = 1;
			b->MarkChar += num4 + num5 + num3 - num + 1;
		}
	}
/*
  	#] Move Mark :
  	#[ Split Line :
*/
	if ( ( l2 = LineAlloc(num2+num3+num4+num5,l) ) == 0 ) {
		b->MarkChar = old1;
		b->MarkVoff = old2;
		return(NOMEMORYL);
	}
	if ( l->used >= 0 ) b->newline++;
	else b->newline += LINESINFOLD(l);
	b->totline++;
	if ( movemark ) b->mark = l2;
	s = l2->text;
	num1 = num4; while ( --num1 >= 0 ) { *s++ = '\t'; }
	num1 = num5; while ( --num1 >= 0 ) { *s++ =  ' '; }
	num1 = num3; while ( --num1 >= 0 ) { *s++ = *t++; }
	if ( num2 > 0 ) {
		num1 = num2; do { *s++ = *(fp.address)++; } while ( --num1 > 0 );
		DropPart(l,num2);				/* Deallocate the trailing bytes */
	}
	if ( b->mark == l2 )DetMarkColumn();
	num1 = num3 + num4 + num5;
	b->column = 1;
	if ( num1 > 0 ) b->column += FindColumn(l2,num1);
	b->current = l2;
/*
  	#] Split Line :
*/
	return(0L);
}

/*
 		#] Insert linefeed in text :
 		#[ Insert Character :
*/

LONG
InNorm(UBYTE *sc,WORD n)
{
	BUFFER b = cbuf;
	LONG ret;
	if ( n <= 0 ) return(0);
	ClearUndo();
	if ( ( ret = Cinsert(sc,n) ) < 0 ) return(ret);
	if ( !redraw ) LineDisplay(b->current);
	b->screencolumn = b->column - b->offset;
#ifdef WITHSYNCH
	if ( !redraw ) PSsynch();
#endif
#ifndef DEMO
	if ( ( ( b->wordwrap > 0 ) && ( b->column > b->wordwrap ) )
		|| ( (b->wordwrap < 0 ) && ( b->column > 73 ) ) ) {
		return(WrapWord(b->current,b->column));
	}
#endif
	return(0L);
}

/*
 		#] Insert Character :
 		#[ Insert Linefeed :
*/

LONG
CRnorm(VOID)
{
	LONG ret;
	BUFFER b = cbuf;
	ClearUndo();
	if ( ( ret = Linsert() ) < 0 ) return(ret);
	if ( b->offset > 0 ) { ForceDisplay(); return(0L); }
	if ( !redraw ) {
		if ( b->newvirt == 0 ) {
			PSclreol(TextScreen,b->screenline,b->screencolumn);
		}
		if ( b->screenline > ( TextScreen->hi - 4 ) ) {
			ScrollUp(b->screenline,b->current);
			b->screenline--;
		}
		else {
			ScrollDown(b->screenline+1,b->current);
		}
	}
	UpdateDisplay();
	return(0L);
}

/*
 		#] Insert Linefeed :
 		#[ Delete Character in text :
*/

LONG
Tdelete(VOID)
{
	BUFFER b = cbuf;
	LINE l, l2;
	WORD num, virt, n, num1, num2, type;
	UBYTE *address, *s;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	l = b->current;
	if ( l->used < 0 ) return(NoFold());
	if ( b->newvirt > 0 ) return(0L);		/* In virtual line */
	type = FindChar(l,b->column,&fp);
	n = l->used - LINEHEAD;
	address = fp.address; num = fp.num; virt = fp.virt;

	if ( type == AFTERVIRTUAL || type == NORMALEOL ) {
 
		/* compose a new line from the characters of this one,
		   virt blanks and the characters of the next line */

		if ( commandmode ) return(0L);
		if ( l->next == (LINE)b ) return(0L);
		if ( l->next->used < 0 ) {
			if ( b->column != 1 )return(NoFold());
			return(Ldelete());
		}
		num1 = l->used - LINEHEAD;
		num2 = l->next->used - LINEHEAD;
		n = num1 + num2 + virt;
 		b->dirtyflag = 1;
		if ( n <= ( l->totlen - LINEHEAD ) ) {
			if ( AddUndo(l,UNDOEOL) < 0 ) return(NOMEMORYL);
			l->used = n + LINEHEAD;
			if ( ( b->mark == l ) && ( b->MarkVoff > 0 )
				&& ( b->MarkVirt == 0 ) ) {
				if ( b->MarkVoff > virt ) { remomk(); }
				else {
					b->MarkChar += b->MarkVoff - 1;
					b->MarkVoff = 0;
				}
			}
			else if ( ( b->mark == l->next ) && ( b->MarkVirt == 0 ) ) {
				b->mark = l;
				b->MarkChar += num1 + virt;
				if ( b->MarkVoff < 0 ) b->MarkVoff = 0;
			}
			s = l->text + num1;
			while ( --virt >= 0 ) *s++ = ' ';
			address = l->next->text;
			while ( --num2 >= 0 ) *s++ = *address++;
			LineDealloc(l->next);
		}
		else {
			if ( n > MAXINLINE ) {
				MesnOut(14);
				return(-1L);
#ifdef NOTHING
				MesnOut(4);  /* "Truncate too long line? (Y/N) " */
				if ( MesAsk(98,INCOMMAND) <= 0 ) return(-1L);
				n = MAXINLINE;
#endif
			}
			if ( AddUndo(l,UNDOEOL) < 0 ) return(NOMEMORYL);
			if ( ( l2 = LineAlloc(n,l) ) == 0 ) return(NOMEMORYL);
			if ( ( b->mark == l ) && ( b->MarkVoff > 0 )
				&& ( b->MarkVirt == 0 ) ) {
				if ( b->MarkVoff > virt ) { remomk(); }
				else {
					b->mark = l2;
					b->MarkChar += b->MarkVoff - 1;
					b->MarkVoff = 0;
				}
			}
			else if ( ( b->mark == l->next ) && ( b->MarkVirt == 0 ) ) {
				b->mark = l2;
				b->MarkChar += num1 + virt;
				if ( b->MarkVoff < 0 ) b->MarkVoff = 0;
			}
			else if ( ( b->mark == l ) && ( b->MarkVirt == 0 ) ) {
				b->mark = l2;
			}
			s = l2->text;
			address = l->text;
			while ( ( --num1 >= 0 ) && ( --n >= 0 ) ) *s++ = *address++;
			while ( ( --virt >= 0 ) && ( --n >= 0 ) ) *s++ = ' ';
			address = l2->next->text;
			while ( ( --num2 >= 0 ) && ( --n >= 0 ) ) *s++ = *address++;
			LineDealloc(l2->next);
			LineDealloc(l);
			b->current = l = l2;
		}
		b->totline--;
		if ( b->mark == l ) DetMarkColumn();
		return(1L);
	}
	else {

		if ( !commandmode && ( AddUndo(l,UNDOPART) < 0 ) ) return(NOMEMORYL);
		b->dirtyflag = 1;
		s = address;
		n -= num;
		while ( --n >= 0 ) { *s = *(s+1); s++; }
		if ( ( l == b->mark ) && ( b->MarkVirt == 0 ) ) {
			if ( ( b->MarkChar == num ) && ( b->MarkVoff <= 0 ) ) {
				remomk();
			}
			else if ( b->MarkChar >= num ) {
				b->MarkChar--;
				DetMarkColumn();
			}
		}
		b->column = 1;
		if ( num != 1 ) b->column += FindColumn(l,num-1);
		DropPart(l,1);
		return(0L);

	}
}

/*
 		#] Delete Character in text :
 		#[ Delete Character :
*/

LONG
Cdelete(VOID)
{
	BUFFER b = cbuf;
	LONG ret;
	if ( commandmode ) {
		return(-1L);
	}
	else {
		if ( ( ret = Tdelete() ) < 0 ) return(ret);
		if ( !redraw ) {
			if ( b->newvirt <= 0 ) LineDisplay(b->current);
			if ( ret == 1 ) PullUp((WORD)(b->screenline+1),b->current->next);
		}
	}
	UpdateDisplay();
#ifdef WITHSYNCH
	if ( !redraw ) PSsynch();
#endif
	return(0L);
}

/*
 		#] Delete Character :
 		#[ Backspace :

	Action: In insert mode: Backwards delete, eat <cr>, eat tab, but
			inside virtual territory it is equivalent to left arrow.
			In overstrike mode: Left arrow, overstrike with a space
			and again a left arrow.
*/

LONG
Bdelete(VOID)
{
	BUFFER b = cbuf;
	WORD type;
	UBYTE blank = ' ';
	LONG ret;
	FINDPOS fp;
	if ( commandmode ) return(-1L);
	if ( b->column == 1 ) {	/* Go to end of previous line and do Cdelete */
		if ( b->newvirt > 0 ) {
			if ( ( b->newvirt == 1 ) && ( b->current == (LINE)b ) ) return(0L);
			UpOne();
			if ( b->newvirt == 0 ) ToEOL();
			DoDisplay();
			return(0);
		}
		if ( b->current->prev == (LINE)b ) return(0L);
		UpOne(); UpdateDisplay(); ToEOL();
		return(Cdelete());
	}
	l_arrow();
	type = FindChar(b->current, b->column, &fp );
	if ( type != ONTAB && type != NORMALCHAR ) return(0L);
/*
	if ( ( type == INSIDETAB ) || ( type == AFTERVIRTUAL ) ||
		 ( type == NORMALEOL ) ) return(0L);
*/
	if ( b->iomode == OVERSTRIKEMODE ) {
		ret = Cinsert(&blank,1);
		if ( ret < 0 ) { r_arrow(); return(ret); }
		else		   {
			l_arrow();
			LineDisplay(b->current);
#ifdef WITHSYNCH
			if ( !redraw ) PSsynch();
#endif
			return(0L);
		}
	}
	return(Cdelete());
}

/*
 		#] Backspace :
 		#[ Delete Line :
*/

LONG
Ldelete(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	if ( commandmode ) {
		commandbuffer->column = 1;
		return(deleol());
	}
	if ( b->newvirt > 0 ) return(0L);
	if ( b->current->used < 0 ) return(NoFold());
	KeyFlush();
	l = b->current->prev;
	if ( b->current == b->mark ) {
		if ( b->MarkVirt > 0 ) b->mark = b->mark->prev;
		else remomk();
	}
	AddUndo(b->current,UNDOLINE);
	b->dirtyflag = 1;
	b->column = 1;
	b->totline--;
	if ( l->next == (LINE)b ) {
		b->current = l;
		b->newvirt = 1;
		b->newline = b->totline;
		if ( l == (LINE)b ) {
			b->screenline = b->oldvirt = 1;
			b->oldline = 0;
		}
		if ( b->offset > 0 ) ForceDisplay();
		else {
			UpdateDisplay();
			if ( !redraw ) PSclreol(TextScreen,b->screenline,b->screencolumn);
		}
	}
	else {
		b->current = l->next;
		if ( b->offset > 0 ) {
			ForceDisplay();
		}
		else {
			PullUp(b->screenline,b->current);
			UpdateDisplay();
		}
	}
	return(0L);
}

/*
 		#] Delete Line :
 		#[ Mark operations :
			#[ Determine mark : VOID DetMark()
*/

VOID
DetMark(VOID)
{
	BUFFER b = cbuf;
	WORD type;
	FINDPOS fp;
	if ( b->MarkVirt != 0 ) {
		b->MarkVoff = b->MarkColumn;
		b->MarkChar = 0;
	}
	else {
		type = FindChar(b->mark,b->MarkColumn,&fp);
		b->MarkChar = fp.num; b->MarkVoff = fp.virt;
		if ( ( type == INSIDETAB ) || ( type == ONTAB ) )
			b->MarkVoff = -b->MarkVoff;
		else if ( ( type == NORMALEOL ) || ( type == AFTERVIRTUAL ) )
			b->MarkVoff++;
	}
}

/*
			#] Determine mark :
			#[ Determine column : VOID DetMarkColumn()
*/

VOID
DetMarkColumn(VOID)
{
	BUFFER b = cbuf;
	WORD col;
	if ( commandmode ) b = commandbuffer;
	if ( b->MarkVoff >= 0 ) {
		col = b->MarkVoff;
		if ( b->MarkVirt <= 0 ) col += FindColumn(b->mark,b->MarkChar);
	}
	else {
		col = -b->MarkVoff + 1;
		if ( b->MarkChar != 1 ) col += FindColumn(b->mark,b->MarkChar-1);
	}
	if ( col == 0 ) col = 1;
	b->MarkColumn = col;
}

/*
			#] Determine column :
			#[ Put a mark :
*/

LONG
setmrk(VOID)
{
	BUFFER b = cbuf;
	if ( commandmode ) return(-1L);
	b->mark = b->current;
	if ( b->mark != (LINE)b ) {
		b->MarkColumn = b->column;
		b->MarkVirt = b->newvirt;
		DetMark();
	}
	else {
		b->MarkVirt = b->newvirt;
		b->MarkVoff = b->MarkColumn = b->column;
		b->MarkChar = 0;
	}
	if ( DispBlock <= 0 ) MesnOut(5); /* "Mark set." */
	return(0L);
}

/*
			#] Put a mark :
			#[ Remove Mark :
*/

LONG
remomk(VOID)
{
	BUFFER b = cbuf;
	if ( commandmode ) return(-1L);
	if ( ( b->mark != (LINE)b ) || ( b->MarkVirt > 0 ) ) {
		b->mark = (LINE)b;
		b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
		if ( DispBlock <= 0 ) MesnOut(6); /* "Mark removed." */
		return(0L);
	}
	return(NoMark());
}

/*
			#] Remove Mark :
			#[ Go to mark :
*/

LONG
gotomk(VOID)
{
	BUFFER b = cbuf;
	LONG num;
	if ( commandmode ) return(-1L);
	if ( ( b->mark == (LINE)b ) && ( b->MarkVirt <= 0 ) ) return(NoMark());
	if ( ( num = FindNum(b->mark) ) < 0 ) {
		MesnOut(7); /* "Mark not found." */
		return(num);
	}
	b->newline = num;
	b->current = b->mark;
	b->column = b->MarkColumn;
	b->newvirt = b->MarkVirt;
	DoDisplay();
	return(0L);
}

/*
			#] Go to mark :
			#[ Exchange mark :
*/

LONG
exgmrk(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD x;
	LONG num;
	if ( commandmode ) return(-1L);
	if ( ( b->mark == (LINE)b ) && ( b->MarkVirt <= 0 ) ) return(NoMark());
	if ( ( num = FindNum(b->mark) ) < 0 ) {
		MesnOut(7); /* "Mark not found." */
		return(num);
	}
	b->newline = num;
	l = b->mark; b->mark = b->current; b->current = l;
	x = b->column; b->column = b->MarkColumn; b->MarkColumn = x;
	x = b->newvirt; b->newvirt = b->MarkVirt; b->MarkVirt = x;
	DetMark();
	DoDisplay();
	return(0L);
}

/*
			#] Exchange mark :
 		#] Mark operations :
 		#[ Transpose characters :
*/

LONG
twidle(VOID)
{
	BUFFER b = cbuf;
	WORD type;
	UBYTE *address, c;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	if ( b->current == (LINE)b ) return(0L);
	if ( b->current->used < 0 ) return(NoFold());
	if ( b->column <= 2 ) return(0L);
	type = FindChar(b->current, b->column-1, &fp);
	address = fp.address;
	if ( type == NORMALCHAR )  {
		if ( ( fp.num >= 2 ) && ( *(address-1) != '\t' ) ) {
			b->dirtyflag = 1;
			c = *address; *address = address[-1]; address[-1] = c;
			if ( commandmode ) MessageCommand();
			else {
				LineDisplay(b->current);
#ifdef WITHSYNCH
				if ( !redraw ) PSsynch();
#endif
			}
		}
	}
	return(0L);
}

/*
 		#] Transpose characters :
 		#[ FlipLines :

		Exchanges the current line and the next line.
*/

LONG
FlipLines(VOID)
{
	BUFFER b = cbuf;
	LINE l, n;
	if ( commandmode ) return(0);
	if ( b->newvirt ) return(0);
	l = b->current;
	n = l->next;
	if ( l == (LINE)b || n == (LINE)b ) return(0);
	l->prev->next = n;
	n->next->prev = l;
	l->next = n->next; n->prev = l->prev;
	l->prev = n; n->next = l;
	if ( b->screenline < TextScreen->hi ) PutOut(b->screenline+1,1,l);
	b->current = n;
	PutOut(b->screenline,1,n);
	b->dirtyflag = 1;
	return(0);
}

/*
 		#] FlipLines :
 		#[ Delete to end of line :
*/

LONG
deleol(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type, num;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	if ( b->newvirt > 0 ) return(0L);
	l = b->current;
	if ( l->used < 0 ) return(NoFold());
	if ( !commandmode && ( AddUndo(l,UNDOPART) < 0 ) ) return(NOMEMORYL);
	type = FindChar(l,b->column,&fp);
	num = fp.num;
	if ( ( b->mark == l ) && ( b->MarkVirt == 0 ) ) {
		if ( ( b->MarkChar > num ) || ( ( b->MarkChar == num ) &&
			( ( b->MarkVoff > fp.virt ) || ( b->MarkVoff <= -fp.virt ) ) ) ) {
			remomk();
		}
	}
	if ( type != AFTERVIRTUAL && type != NORMALEOL )
/*
	if ( ( type == NORMALCHAR ) || ( type == INSIDETAB ) || ( type == ONTAB ) )
*/
	{
		num = l->used - LINEHEAD - num + 1;
		b->dirtyflag = 1;
		DropPart(l,num);
		if ( commandmode ) MessageCommand();
		else {
			UpdateDisplay();
			PSclreol(TextScreen,b->screenline,b->screencolumn);
		}
	}
	return(0L);
}

/*
 		#] Delete to end of line :
 		#[ Insert Line :
*/

LONG
insert(VOID)
{
	BUFFER b = cbuf;
	WORD autoin = b->autoindent;
	LONG retcode;
	if ( commandmode ) return(0L);
	if ( b->first == b->current ) b->autoindent = 0;
	if ( ( ( b->totline > 1 ) && ( b->newline > 1 ) ) ||
		 ( ( b->newline + b->newvirt ) > 1 ) ) {
		UpOne(); UpdateDisplay(); ToEOL(); UpdateDisplay();
		retcode = CRnorm();
		b->autoindent = autoin;
		return(retcode);
	}
	sl_arr(); UpdateDisplay();
	retcode = CRnorm();
	b->autoindent = autoin;
	if ( retcode < 0 ) return(-1);
	return(u_arrow());
}

/*
 		#] Insert Line :
 		#[ Append Line :
*/

LONG
append(VOID)
{
	ToEOL(); UpdateDisplay();
	return(CRnorm());
}

/*
 		#] Append Line :
 		#[ Hex character insertion :
*/

LONG
puth(VOID)
{
	if ( commandmode > 1 ) { hexmode = 0; return(InsertOne(8)); }
	if ( hexmode ) ClearHexMode();
	hexmode = 1;
	return(0L);
}

VOID
ClearHexMode(VOID)
{
	if ( hexmode > 1 ) { hexmode = 0; InsertOne(HexBuffer); }
	hexmode = 0;
}

/*
 		#] Hex character insertion :
 	#] Basic operations :
*/

