/*
  	#[ Include file :
*/
#include "stedi.h"
/*
  	#] Include file :
  	#[ Key redefinitions :
*/
#ifndef DEMO

LONG
KeyDefRead(UBYTE *s,WORD n)
{
	UBYTE *t, name[128];
#ifdef WITHSWAP
	UBYTE *u, c, c1, c2;
#endif
	LONG len, leng, Lhandle, ret, *stop;
	LONG *k, *KeysIn;
	LONG num, n1, n2;
	WORD handle;
#ifdef WITHSWAP
	WORD swapper = 0;
#endif
	if ( n <= 0 ) return(Syntax());
	if ( *s == '0' ) {
		n--; s++;
		SKIPBLANKS(s,n);
		if ( n > 0 ) return(Syntax());
		if ( dbufFer.redeflength > 0 ) {
			NumberKeys = dbufFer.redeflength = dbufFer.numredef = 0;
			Mfree(KeyPointer);
		}
		return(0L);		
	}
	if ( *s == '\'' || *s == '=' ) { s++; n--; }
	if ( n <= 0 ) return(Syntax());
	t = name;
/*
	c = *(s+n);
	*(s+n) = '\0';
	Strcpy(s,t);
*/
	while ( --n >= 0 ) *t++ = *s++;
	*t = 0;
	if ( ( Lhandle = MyOpen(name,O_RDONLY) ) < 0 ) {
/*
		t = name;
		u = defaultdir;
		while ( *u ) *t++ = *u++;
		Strcpy(s,t);
		if ( ( Lhandle = MyOpen(name,O_RDONLY) ) < 0 )
*/
		{
			MesPrint(9,name); /* "Cannot find file %s" */
/*
			MesPrint(9,s);
			*(s+n) = c;
*/
			return(-1L);
		}
	}
	handle = (WORD)Lhandle;
	len = FileSeek(0L,handle,2);
	FileSeek(0L,handle,0);
/*
	*(s+n) = c;
*/
	if ( ( KeysIn = (LONG *)MALLOC((LONG)len) ) == 0 ) {
		MesMem();
		CloseFile(handle);
		return(-1L);
	}
	ret = FileRead(handle,len,(BYTE *)KeysIn);
	CloseFile(handle);
	if ( ret != len ) {
		MesnOut(26); /* "Error while reading." */
		Mfree(KeysIn);
		return(-1L);
	}
	len &= - (LONG)(sizeof(LONG));
	stop = (LONG *)(((UBYTE *)KeysIn) + len);
#ifdef WITHSWAP
  redoKey:
#endif
	num = 0;
	k = KeysIn;
	while ( k < stop ) {
		leng = *k++;
		n1 = *k++;
		k += n1;
		n2 = *k++;
		if ( ( ( ( n1+n2+3 ) << 2 ) != leng ) || ( k > stop ) ) {
#ifdef WITHSWAP
			if ( swapper ) {
#endif
				MesnOut(79); /* "Illegal keyredefinition file." */
				Mfree(KeysIn);
				return(-1L);
#ifdef WITHSWAP
			}
			swapper = 1;
			t = u = (UBYTE *)KeysIn;
			while ( u < (UBYTE *)stop ) {
				c = *u++;
				c1 = *u++;
				c2 = *u++;
				*t++ = *u++;
				*t++ = c2;
				*t++ = c1;
				*t++ = c;
			}
			goto redoKey;
#endif
		}
		k += n2;
		num++;
	}
	NumberKeys = dbufFer.numredef = num;
	dbufFer.redeflength = len;
	Mfree(KeyPointer);
	KeyPointer = KeysIn;
#ifdef PORTWIN
	ResetPrivate();
#endif
	return(0L);
}
#endif

/*
  	#] Key redefinitions :
  	#[ Execution of external programs :

	Routines for the 'execute an external program' command.
	Syntax :
	!	General execute of the following program + tail.
	!+	With waiting for any key after execution
	!-	Without waiting for any key after execution

*/
#ifndef DEMO

LONG
xtern(UBYTE *s,WORD n)
{
	UBYTE TailString[MAXTAIL+2], ProgramString[MAXIPATH];
	UBYTE *end;
	WORD WaitFlag;
	UBYTE *t;
	WORD i;
	LONG ret, time;
	WaitFlag = dbufFer.waitflag;
#ifndef __WATCOMC__
	if ( n <= 0 ) return(0);
#endif
	if ( *s == '+' && n > 0 ) {
		WaitFlag = ON;
		s++; n--;
	}
	else if ( *s == '-' && n > 0 ) {
		WaitFlag = OFF;
		s++; n--;
	}
	t = ProgramString;
	i = 0;
	while ( ( n > 0 ) && ( *s != ' ' ) &&
			( *s != '\t' ) && ( i < MAXIPATH ) )
		{ *t++ = *s++; n--; i++; }
	if ( i == MAXIPATH ) {
		while ( ( n > 0 ) && ( *s != ' ' ) &&
			( *s != '\t' ) ) { s++; n--; }
	}
	*t = '\0';
	end = t - 4;
	s++; n--;		/* Skip one blank or tab */
	if ( n < 0 ) n = 0;
	t = TailString;
	if ( n > MAXTAIL ) n = MAXTAIL;
	*t++ = n;
	while ( n > 0 ) { n--; *t++ = *s++; }
	*t = '\0';
#ifdef UNIX
	PSend();
#else
#ifdef LINUX
	PSend();
#else
	KeyEnd();
#endif
#endif
/*
	End is a pointer to a three character extension. It is meant
	for use in some micro systems that use an MSDOS-like files name
	system (extensions of up to three characters) and a fixed
	extension for some types of programs.
	Time is the time taken for the execution in milliseconds.
*/
#ifdef PORTWIN
	ret = Excute((BYTE *)ProgramString,(BYTE *)TailString,&time,WaitFlag);
#ifdef UNIX
	PSbegin();
#else
#ifdef LINUX
	PSbegin();
#endif
#endif
#else
	ret = Excute((BYTE *)ProgramString,(BYTE *)TailString,(BYTE *)end,&time);
#ifdef UNIX
	PSbegin();
#else
#ifdef LINUX
	PSbegin();
#endif
#endif
	KeyFlush();						/* flush input */
	PSbeep();
	if ( WaitFlag ) KeyChar();		/* Wait for any character */
#endif
	if ( dbufFer.color & 1 ) PScolor();
	SetScreen(0);
	UpdateAll();
#ifdef ATARI
	{
		WORD decitime = (lwdiv(&time,(WORD)1000))/100;
		MesPrint(25,time,decitime);
	}
#else
	time /= 100;
	MesPrint(25,(LONG)(time/10),(WORD)(time%10));
#endif
		 /* "Executiontime = %l.%d sec." */
#ifdef __WATCOMC__
	return(0);
#else
	return(ErrorMes(ret,(WORD)1));
#endif
}
#endif

/*
  	#] Execution of external programs :
  	#[ Command line and special characters :
 		#[ iniCommand :
*/

VOID
iniCommand(VOID)
{
	BUFFER b = commandbuffer;
	b->first = b->last = b->current = b->mark = (LINE)b;
	b->column = 1;
	b->offset = 0; b->oldline = b->newline = b->totline = 0;
	b->oldvirt = b->newvirt = 0;
	b->iomode = dbufFer.iomode;
	b->tabstring[0] = 0;
}

/*
 		#] iniCommand :
 		#[ InsertOne :
*/

LONG
InsertOne(WORD c)
{
	LONG ret;
	WORD y;
	UBYTE cc;
	if ( hexmode ) {
		y = ToUpper[c&0xFF];
		if ( ( y >= '0' && y <= '9' ) || ( y >= 'A' && y <= 'F' ) ) {
			y -= '0';
			if ( y > 9 ) y -= 'A' - '9' - 1;
			if ( hexmode == 1 ) {
				hexmode = 2;
				HexBuffer = c;
				return(0L);
			}
			hexmode = 0;
			c = y;
			y = ToUpper[HexBuffer&0xFF] - '0';
			if ( y > 9 ) y -= 'A' - '9' - 1;
			c += y << 4;
		}
		else ClearHexMode();
	}
	cc = c;
	if ( commandmode ) {
		if ( ( ret = Cinsert(&cc,1) ) < 0 ) return(ret);
		MessageCommand();
		return(0L);
	}
	return(InNorm(&cc,1));
}

/*
 		#] InsertOne :
 		#[ escape :
*/

LONG
escape(VOID)
{
	BUFFER b = commandbuffer;
	WORD i;
	LINE l;
	LONG ret;
	UBYTE esc = 0x1B;
	if ( !commandmode ) { /* Go to commandmode and start a new line */
		if ( b->totline == 0 ) {	/* first command */
			l = LineAlloc(0,(LINE)b);
			if ( l == (LINE)0 ) return(NOMEMORYL);
			b->totline = 1;
		}
		else {
			if ( b->totline >= 2 && b->first->used == b->first->next->used ) {
				UBYTE *s, *t;
				i = b->first->used - LINEHEAD;
				s = b->first->text;
				t = b->first->next->text;
				while ( --i >= 0 ) {
					if ( *s != *t ) break;
					s++; t++;
				}
				if ( i < 0 ) goto NoNewLine;
			}
			if ( CopyLine(b->first,(LINE)b) < 0 ) {
				/* No memory -> erase history. Use old line. */
				i = (WORD)b->totline - 1;
				while ( --i >= 0 ) LineDealloc(b->last);
				b->totline = 0;
			}
			b->totline++;
NoNewLine:;
		}
		b->column = 1; b->newline = 1;
		if ( b->totline <= 1 ) b->oldline = 1;
		else				   b->oldline = 2;
		b->current = b->first;
		i = dbufFer.maxhist + 1;
		while ( ( b->totline > i ) && ( b->totline > 1 ) ) {
			LineDealloc(b->last);
			b->totline--;
		}
		commandmode = 1;
#ifdef PORTWIN
		WinCommand();
#endif
	}
	else {
			/* 1: Go to Escape mode, 2: get out from it */
		i = 3 - commandmode;
		commandmode = 1;
		if ( ( ret = Cinsert(&esc,1) ) < 0 ) return(ret);
		commandmode = i;
	}
	MessageCommand();
	return(0L);
}

/*
 		#] escape :
 		#[ newline :
*/

LONG
newline(WORD type)
{
	BUFFER b = commandbuffer;
	LINE l;
	WORD n;
	LONG ret;
	UBYTE ctype = type;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&ctype,1) ) < 0 ) return(ret);
			MessageCommand();
			return(0L);
		}
		l = b->current;
		n = l->used - LINEHEAD;
		if ( b->column <= n ) {
			DropPart(l,(WORD)(n-b->column+1));
			n = b->column - 1;
		}
		if ( InMustWrite > 0 ) {
			b->current = l->next;
			l->next->prev = l->prev;
			l->prev->next = l->next;
			b->totline--;
			l->next = 0;
			InMustWrite = 0;
		}
		MessageCommand();
#ifdef PORTWIN
		WinText();
#endif
		return(DoCommand(l,(LINE)b));
	}
	return(CRnorm());
}

/*
 		#] newline :
 		#[ backspace :
*/

LONG
backspace(VOID)
{
	LONG ret;
	UBYTE bs = 8;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&bs,1) ) < 0 ) return(ret);
		}
		else if ( commandbuffer->column > MinCommandColumn ) {
			commandbuffer->column--;
			if ( ( ret = Tdelete() ) < 0 ) {
				commandbuffer->column++;
				return(ret);
			}
		}
		MessageCommand();
		return(0L);
	}
	return(Bdelete());
}

/*
 		#] backspace :
 		#[ delete :
*/

LONG
delete(VOID)
{
	LONG ret;
	UBYTE bs = 0x7F;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&bs,1) ) < 0 ) return(ret);
		}
		else if ( ( ret = Tdelete() ) < 0 ) return(ret);
		MessageCommand();
		return(0L);
	}
	return(Cdelete());
}

/*
 		#] delete :
  	#] Command line and special characters :
  	#[ Pause :

	Wait a given number of deciseconds.
*/

LONG
Pause(UBYTE *s,WORD n)
{
	LONG x;
	NumVal(s,(LONG)n,&x);
	if ( !commandmode ) TextCursor();
	if ( !redraw ) CursorOn();
	MyWait(GetTicks() + x*100);
	if ( !redraw ) CursorOff();
	return(0);
}

/*
  	#] Pause :
*/

